/*
 * Copyright (c) 2005
 *	Deutsches Zentrum fuer Luft- und Raumfahrt DLR.
 *	All rights reserved.
 *
 * Author: Harti Brandt <hartmut.brandt@dlr.de>
 *
 * Redistribution of this software and documentation and use in source and
 * binary forms, with or without modification, are permitted provided that
 * the following conditions are met:
 *
 * 1. Redistributions of source code or documentation must retain the above
 *    copyright notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE AND DOCUMENTATION IS PROVIDED BY FRAUNHOFER FOKUS
 * AND ITS CONTRIBUTORS ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL
 * FRAUNHOFER FOKUS OR ITS CONTRIBUTORS  BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA,
 * OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * $Id: mtrand.h 6 2005-05-04 06:55:20Z brandt_h $
 */

#ifndef mtrand_h_1115135216
#define mtrand_h_1115135216

#ifdef __cplusplus
extern "C" {
#endif

/* opaque data */
struct mtrand;

/* initialize with seed */
struct mtrand *mtrand_init(unsigned long);

/* initialize with seed array */
struct mtrand *mtrand_init_by_array(const unsigned long [], int);

/* generated uint32_t */
unsigned long mtrand_uint32(struct mtrand *);

/* generate int32_t >= 0 */
long mtrand_int31(struct mtrand *);

/* generate double [0, 1] */
double mtrand_double1(struct mtrand *mt);

/* generate double [0, 1) */
double mtrand_double2(struct mtrand *mt);

/* generate double (0, 1) */
double mtrand_double3(struct mtrand *mt);

/* generate double [0, 1) with 53 bit of randomness */
double mtrand_res53(struct mtrand *mt);

#ifdef __cplusplus
};
#endif

#endif
